//
// File: IPv4Socket.h
// Created by: Kristian Müller <Kristian-M@Kristian-M.de>
// Created on: Wed Oct  1 15:18:38 2003
//

#ifndef _IPV4SOCKET_H_
#define _IPV4SOCKET_H_


#include <netinet/in.h>

#include <sys/time.h>	/* select */
#include <sys/types.h>	/* select */
#include <sys/select.h>	/* select */

#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <err.h>

#include "ErrorHandler.h"


class IPv4Socket{
	protected:
		char *sIPv4Hostname;
  	char *sIPv4Address;
		int iIPv4Port;
		int iIPv4SocketDescriptor;
		struct sockaddr_in aSocketAddress;
		bool bConnected;
	private:
	  char *resolveHost(char *sHostName);
	public:
		IPv4Socket(char *sHostname, const int iIPv4Port);
 	  ~IPv4Socket();
		bool isConnected() {return bConnected; };

		int setPort(int);
		int connectSocket();
		int writeToSocket(void *aPacketData, int iLenght);
		int readFromSocket(void *aPacketData, int iLenght);
};


#endif	//_IPV4SOCKET_H_
