// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// File: StatusHandler.h
// Created by: Kristian Müller <Kristian-M@Kristian-M.de>
// Created on: Wed Jul 30 00:49:47 2003
//

#include "../include/StatusHandler.hh"
#include "../include/GVar.h"
#include "../include/ErrorHandler.h"

// #include <iostream.h>  //debugging

StatusHandler::StatusHandler(){
  aAirportSocket = NULL;
	sOnlineTime = NULL;
}


StatusHandler::~StatusHandler(){
  if (aAirportSocket != NULL) delete aAirportSocket;
  if (sOnlineTime != NULL) delete[] sOnlineTime;
}

int StatusHandler::updateStatus(char *sInAddress){
	GVar aGVar;
	int iReturnedStatus = 1;
	char *sTempTimeString;
	StatusData *aTempStatusData = NULL;

	if (sInAddress==NULL) return -1;
	if (strlen(sInAddress) ==0) return -1;
		

	// strncpy (sAddress, aGVar.getDefaultIP(), 15);	
  // if (sInAddress != NULL)
	//	strncpy(sAddress, sInAddress, 15);  // TODO !!
	
	if (aAirportSocket != NULL){
		delete aAirportSocket;		//we need a fresh Socket here
	}
	aAirportSocket = new AirportSocket(sInAddress);

	aTempStatusData = aAirportSocket->getStatus(&aTempStatusData);
	if (aTempStatusData == NULL){
		iReturnedStatus = -1;
	} else{
		sTempTimeString = aTempStatusData->getOnlineTime();
		sOnlineTime = new char[strlen(sTempTimeString)+1];
		strncpy (sOnlineTime, sTempTimeString, strlen(sTempTimeString));
		sOnlineTime[strlen(sTempTimeString)] = '\0';
		iReturnedStatus = aTempStatusData->getOnlineStatus();
	}
	
	if (aAirportSocket != NULL){
		delete aAirportSocket; 
		aAirportSocket=NULL;
	};
	return iReturnedStatus;
}

int StatusHandler::setConnected(int iInConnect, const char *sInAddress){
	GVar aGVar;
	ErrorHandler aErrorHandler;
	char *sAddress;
  struct hostent *aResolv;
	
	if (strlen(sInAddress) <= 15) 
	  sAddress = new char[16];
	else 
	  sAddress = new char[strlen(sInAddress)+1];
	strcpy (sAddress, aGVar.getDefaultIP());       	//, 15);	
  if (sInAddress != NULL)
		strcpy(sAddress, sInAddress);           			//, strlen(sInAddress));
	if (aAirportSocket != NULL) delete (aAirportSocket);		//we need a fresh Socket here
	aAirportSocket	= new AirportSocket(sAddress);
	if (aAirportSocket->connectSocket() != 1) return -1;
	if (iInConnect == true) 
		aAirportSocket->connectModem();
	else 
		aAirportSocket->disconnectModem();
	return 0;
}
